﻿Imports MySql.Data.MySqlClient

Public Class Form1

    Sub calcAmountOfItems()
        AmountItems.Text = ItmList.Items.Count.ToString()
    End Sub

    Sub makeReportAndOutputFile()
        Report.TextBox1.Text = "Begin report:" + ControlChars.NewLine + ControlChars.NewLine
        Dim lastPlace As Integer = ItmList.Items.Count
        For Each item As ListViewItem In ItmList.Items
            Report.TextBox1.Text += item.Text + " : " + lastPlace.ToString + ControlChars.NewLine
            lastPlace -= 1
        Next
        Report.TextBox1.Text += "End report"
        Report.ShowDialog()
    End Sub

    Sub makeSQLCode()
        SQLQuery.Query.Text = ""
        If ShopID.Text = "" Or Not IsNumeric(ShopID.Text) Then
            MsgBox("Sorry, but the NPC id is not a number OR empty! Please fix this :)", MsgBoxStyle.Exclamation And MsgBoxStyle.OkOnly, "T_T")
            ShopID.Focus()
            Return
        End If
        If NPCId.Text = "" Or Not IsNumeric(NPCId.Text) Then
            MsgBox("Sorry, but the NPC id is not a number OR empty! Please fix this :)", MsgBoxStyle.Exclamation And MsgBoxStyle.OkOnly, "T_T")
            NPCId.Focus()
            Return
        End If
        If CInt(AmountItems.Text) = 0 Then
            MsgBox("Please add items before you want to create an Query!", MsgBoxStyle.Exclamation And MsgBoxStyle.OkOnly, "T_T")
            Return
        End If

        If AddDeleteQuery.Checked Then
            SQLQuery.Query.Text += "DELETE FROM shopdata WHERE shopid = " + ShopID.Text + ";" + ControlChars.NewLine + ControlChars.NewLine
            SQLQuery.Query.Text += "DELETE FROM shopitemdata WHERE shopid = " + ShopID.Text + ";" + ControlChars.NewLine + ControlChars.NewLine
            SQLQuery.Query.Text += "INSERT INTO shopdata (shopid, npcid) VALUES (" + ShopID.Text + ", " + NPCId.Text + ");" + ControlChars.NewLine + ControlChars.NewLine
        End If

        SQLQuery.Query.Text += "INSERT INTO shopitemdata (shopid, itemid, price, sort) VALUES "
        Dim lastPlace As Integer = ItmList.Items.Count

        For Each item As ListViewItem In ItmList.Items
            If lastPlace = 1 Then
                SQLQuery.Query.Text += makeSQLRow(CInt(ShopID.Text), CInt(item.Text), lastPlace, CInt(item.SubItems(1).Text), True)
            Else
                SQLQuery.Query.Text += makeSQLRow(CInt(ShopID.Text), CInt(item.Text), lastPlace, CInt(item.SubItems(1).Text), False)
            End If
            lastPlace -= 1
        Next
        SQLQuery.ShowDialog()
    End Sub

    Function makeSQLRow(ByVal shopId As Integer, ByVal itemID As Integer, ByVal place As Integer, ByVal price As Integer, ByVal isEnd As Boolean) As String
        Dim retString As String = "(" + shopId.ToString() + ", " + itemID.ToString() + ", " + price.ToString() + ", " + place.ToString() + ")"
        If Not isEnd Then
            retString += ", "
        Else
            retString += ";"
        End If
        Return retString
    End Function

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Item_Chooser.ShowDialog()
        If Item_Chooser.Item.SelectedItems.Count = 0 Then
            Return
        Else
            Dim itm As ListViewItem = ItmList.Items.Add(Item_Chooser.items(Item_Chooser.Item.SelectedIndex()).ToString)
            itm.SubItems.Add(Item_Chooser.Price.Text)
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        If ItmList.SelectedItems.Count >= 1 Then
            For Each item As ListViewItem In ItmList.SelectedItems
                item.Remove()
            Next
        End If
        calcAmountOfItems()
    End Sub

    Private Sub MoveListViewItem(ByRef lv As ListView, ByVal moveUp As Boolean)
        Dim i As Integer
        Dim cache As String
        Dim selIdx As Integer

        With lv
            selIdx = .SelectedItems.Item(0).Index
            If moveUp Then
                ' ignore moveup of row(0)
                If selIdx = 0 Then
                    Exit Sub
                End If
                ' move the subitems for the previous row
                ' to cache so we can move the selected row up
                For i = 0 To .Items(selIdx).SubItems.Count - 1
                    cache = .Items(selIdx - 1).SubItems(i).Text
                    .Items(selIdx - 1).SubItems(i).Text = _
                       .Items(selIdx).SubItems(i).Text
                    .Items(selIdx).SubItems(i).Text = cache
                Next
                .Items(selIdx - 1).Selected = True
                .Refresh()
                .Focus()
            Else
                ' ignore move down of last row
                If selIdx = .Items.Count - 1 Then
                    Exit Sub
                End If
                ' move the subitems for the next row
                ' to cache so we can move the selected row down
                For i = 0 To .Items(selIdx).SubItems.Count - 1
                    cache = .Items(selIdx + 1).SubItems(i).Text
                    .Items(selIdx + 1).SubItems(i).Text = _
                       .Items(selIdx).SubItems(i).Text
                    .Items(selIdx).SubItems(i).Text = cache
                Next
                .Items(selIdx + 1).Selected = True
                .Refresh()
                .Focus()
            End If
        End With
    End Sub

    Private Sub ItemUp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ItemUp.Click
        If ItmList.SelectedItems.Count >= 1 Then
            Me.MoveListViewItem(Me.ItmList, moveUp:=True)
        End If
    End Sub

    Private Sub ItemDown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ItemDown.Click
        If ItmList.SelectedItems.Count >= 1 Then
            Me.MoveListViewItem(Me.ItmList, moveUp:=False)
        End If
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        makeReportAndOutputFile()
    End Sub

    Private Sub checkShopId(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If Not IsNumeric(ShopID.Text) And ShopID.Text.Length >= 1 Then
            MsgBox("Please use a number for the shop id", MsgBoxStyle.Information And MsgBoxStyle.OkOnly, ">_>")
            ShopID.Text = ShopID.Text.Remove((ShopID.Text.Length - 1), 1).ToString()
            ShopID.Focus()
        End If
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        makeSQLCode()
    End Sub

    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If Not IsNumeric(NPCId.Text) And NPCId.Text.Length >= 1 Then
            MsgBox("Please use a number for the NPC id", MsgBoxStyle.Information And MsgBoxStyle.OkOnly, ">_>")
            NPCId.Text = NPCId.Text.Remove((NPCId.Text.Length - 1), 1).ToString()
            NPCId.Focus()
        End If
    End Sub

    Private Sub ShowSettingsbtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        MySQLConnectionDialog.ShowDialog()
    End Sub

    Private Sub ToolStripStatusLabel2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DBStatus.Click
        MySQLConnectionDialog.ShowDialog()
    End Sub

    Sub insertRow(ByVal itemid As Integer, ByVal price As Integer)
        Dim itm As ListViewItem = ItmList.Items.Add(itemid.ToString())
        itm.SubItems.Add(price.ToString())

        Dim itm2 = ItemDataList.NewRowIndex


        calcAmountOfItems()
    End Sub

    Private Sub LoadShop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim sid As String = InputBox("Shopid:", "Load Shop")
        Dim ret As MsgBoxResult = MsgBoxResult.Ok
        While ret = MsgBoxResult.Ok And Not sid = "" And Not IsNumeric(sid)
            ret = MsgBox("Only numbers are allowed!", MsgBoxStyle.Information And MsgBoxStyle.OkCancel)
            sid = InputBox("Shopid:", "Load shop")
        End While
        If ret = MsgBoxResult.Cancel Then
            Return
        End If
        ShopID.Text = sid.ToString()
        Dim con As New MySqlConnection
        Dim query As New MySqlCommand
        Dim reader As MySqlDataReader
        con.ConnectionString = "Server=" + MySQLConnectionDialog.MSHost.Text + ";Port=" + MySQLConnectionDialog.MSPort.Text + ";Database=" + MySQLConnectionDialog.MSDB.Text + ";Uid=" + MySQLConnectionDialog.MSUser.Text + ";Pwd=" + MySQLConnectionDialog.MSPass.Text + ";"
        Try
            con.Open()
        Catch ex As MySqlException
            MsgBox("Can't connect to the server! Error message: " + ex.Message + " (Error code " + ex.Number.ToString + ")", MsgBoxStyle.Critical And MsgBoxStyle.OkOnly, " FUUUUUUUUU-")
        End Try
        If con.State = ConnectionState.Open Then
            Try
                query.Connection = con
                query.CommandText = "SELECT itemid, price FROM shopitemdata WHERE shopid = " + sid + " ORDER BY sort DESC"
                reader = query.ExecuteReader()
                ItmList.Items.Clear()
                While reader.Read
                    insertRow(reader.GetValue(reader.GetOrdinal("itemid")), reader.GetValue(reader.GetOrdinal("price")))
                End While
                reader.Close()
                query.CommandText = "SELECT npcid FROM shopdata WHERE shopid = " + sid + " LIMIT 1"
                reader = query.ExecuteReader()
                reader.Read()
                If reader.HasRows Then
                    NPCId.Text = reader.GetString(0)
                    getNPCName(reader.GetString(0))
                End If
                reader.Close()
            Catch ex As MySqlException
                MsgBox("An error ocurred! " + ex.Message, MsgBoxStyle.Critical And MsgBoxStyle.OkOnly)
            Finally
                If con.State <> ConnectionState.Closed Then con.Close()

            End Try

        End If
        calcAmountOfItems()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MySQLConnectionDialog.ShowDialog()
    End Sub

    Private Sub SelectNPC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        NPC_Chooser.ShowDialog()
        If NPC_Chooser.NPC.SelectedItems.Count = 0 Then
            Return
        Else
            NPCId.Text = NPC_Chooser.npcs(NPC_Chooser.NPC.SelectedIndex()).ToString
            getNPCName(NPC_Chooser.npcs(NPC_Chooser.NPC.SelectedIndex()).ToString)
        End If
    End Sub

    Private Sub ReCalcAmountItems_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        calcAmountOfItems()
    End Sub

    Private Sub SelectShop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub LoadShopToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LoadShopToolStripMenuItem.Click
        Dim sid As String = InputBox("Shopid:", "Load Shop")
        Dim ret As MsgBoxResult = MsgBoxResult.Ok
        While ret = MsgBoxResult.Ok And Not sid = "" And Not IsNumeric(sid)
            ret = MsgBox("Only numbers are allowed!", MsgBoxStyle.Information And MsgBoxStyle.OkCancel)
            sid = InputBox("Shopid:", "Load shop")
        End While
        If ret = MsgBoxResult.Cancel Then
            Return
        End If
        ShopID.Text = sid.ToString()
        Dim con As New MySqlConnection
        Dim query As New MySqlCommand
        Dim reader As MySqlDataReader
        con.ConnectionString = "Server=" + MySQLConnectionDialog.MSHost.Text + ";Port=" + MySQLConnectionDialog.MSPort.Text + ";Database=" + MySQLConnectionDialog.MSDB.Text + ";Uid=" + MySQLConnectionDialog.MSUser.Text + ";Pwd=" + MySQLConnectionDialog.MSPass.Text + ";"
        Try
            con.Open()
        Catch ex As MySqlException
            MsgBox("Can't connect to the server! Error message: " + ex.Message + " (Error code " + ex.Number.ToString + ")", MsgBoxStyle.Critical And MsgBoxStyle.OkOnly, " FUUUUUUUUU-")
        End Try
        If con.State = ConnectionState.Open Then
            Try
                query.Connection = con
                query.CommandText = "SELECT itemid, price FROM shopitemdata WHERE shopid = " + sid + " ORDER BY sort DESC"
                reader = query.ExecuteReader()
                ItmList.Items.Clear()
                While reader.Read
                    insertRow(reader.GetValue(reader.GetOrdinal("itemid")), reader.GetValue(reader.GetOrdinal("price")))
                End While
                reader.Close()
                query.CommandText = "SELECT npcid FROM shopdata WHERE shopid = " + sid + " LIMIT 1"
                reader = query.ExecuteReader()
                reader.Read()
                If reader.HasRows Then
                    NPCId.Text = reader.GetString(0)
                    getNPCName(reader.GetString(0))
                End If
                reader.Close()
            Catch ex As MySqlException
                MsgBox("An error ocurred! " + ex.Message, MsgBoxStyle.Critical And MsgBoxStyle.OkOnly)
            Finally
                If con.State <> ConnectionState.Closed Then con.Close()

            End Try

        End If
        calcAmountOfItems()
    End Sub

    Private Sub MakeSQLQueryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MakeSQLQueryToolStripMenuItem.Click
        makeSQLCode()
    End Sub

    Private Sub MakeReportToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MakeReportToolStripMenuItem.Click
        makeReportAndOutputFile()
    End Sub

    Private Sub DAtabaseToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DAtabaseToolStripMenuItem.Click
        MySQLConnectionDialog.ShowDialog()
    End Sub

    Private Sub loadItemData(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ItmList.MouseDoubleClick
        If ItmList.SelectedItems.Count = 0 Then
            Return
        Else
            ItemInfoDialog.Show()
            ItemInfoDialog.itemID = Convert.ToInt32(ItmList.SelectedItems(0).Text)
            ItemInfoDialog.loadItems()
        End If
    End Sub
End Class
